
subroutine CalcEnergy(Pos, NAtom,  L, r2, PEnergy, Dim, Nmax)
    implicit none
    integer, intent(in) :: NAtom, Dim, Nmax
    real(8), intent(in), dimension(0:Nmax-1, 0:Dim-1) :: Pos
    real(8), intent(in) :: L, r2
    integer, intent(out) :: PEnergy
    real(8), dimension(Dim) :: rijx, Posi
    real(8) :: rij2
    integer :: i, j
    PEnergy = 0

    do i = 0, NAtom - 1
        !store Pos(i,:) in a temporary array for faster access in j loop
        Posi = Pos(i,:)
        do j = i + 1, NAtom - 1
            rijx = Pos(j,:) - Posi
            rijx = rijx - L * dnint(rijx / L)
            rij2 = sum(rijx * rijx)
            if (rij2 >= 1 .and. rij2 < r2) then
                !particles are attracted
                PEnergy = PEnergy - 1
            else if (rij2 < 1) then
                !core overlap
                PEnergy = 1
                return
            endif
        enddo
    enddo
end subroutine


subroutine CalcParticleEnergy(P, Pos, NAtom, L, r2, PEnergy, Dim, Nmax)
    implicit none
    integer, intent(in) :: P, NAtom, Dim, Nmax
    real(8), intent(in), dimension(0:Nmax-1, 0:Dim-1) :: Pos
    real(8), intent(in) :: L, r2
    integer, intent(out) :: PEnergy
    real(8), dimension(Dim) :: rijx, Posi
    real(8) :: rij2
    integer :: j
    PEnergy = 0

    !store Pos(P,:) in a temporary array for faster access in j loop
    Posi = Pos(P,:)

    do j = 0, NAtom - 1
        if (j == P) then
            cycle
        endif
        rijx = Pos(j,:) - Posi
        rijx = rijx - L * dnint(rijx / L)
        rij2 = sum(rijx * rijx)
        if (rij2 >= 1 .and. rij2 < r2) then
            !particles are attracted
            PEnergy = PEnergy - 1
        else if (rij2 < 1) then
            !core overlap
            PEnergy = 1
            return
        endif
    enddo
end subroutine
